class ANTLRParser extends Parser;

test1   : "a" "b" "c";

test2   : "a" | "b" ;

test3   : "A" ("a" | "b") "B" ;
 
test4   : ("A")+ ;

test5   : ("A")* ;

test6   : ("A")? ;

test7   : test7_1 ;
test7_1 : test7;

test8   : "a" test8 | "b" test8;

test9   : test9_1 | ".";
test9_1 : "a" test9 "b";

test10  : "a" ("b"|"c") "d";

test11  : "a" ((("b")* "c")+)?;

test12  : "a" ((("b")? "c")+)*;

test13  : "a" ((("b")+ "c")?)*;

test14  : "a" ("a"|"b")*;

test15  : "a" ("a"|"b")+;

test16  : "a" ("a"|"b")?;

test17  : "a" (("b"|"c") | ("d"|"e"))*;

test18  : "a" (test18_1)*;
test18_1: ("b"|"c") | ("d"|"e");

test19  : "a" ("b"|"c") ("d"|"e");

test20  :  ( "a" )+   ( "b" )  	;

test21  : "a" test21 | "." | "b" test21 ;

test22 : 
  (
	    "count" "("  ")" 
	| ( "a"
	  | "b" 
    ) "("  ")"   
  ) ;
  
test23 : ("a")=> "b";